Subject: Re: post-freeze damage control

From: Tom Lane <[email-masked]>
Date: Tue, 09 Apr 2024 17:05:02 -0400

Alexander Korotkov <[email-masked]> writes:
> On Tue, Apr 9, 2024 at 11:37 PM Tom Lane <[email-masked]> wrote:
>> What exactly is the point of having a NodeTag in the struct though?
>> If you don't need it to be a valid Node, that seems pointless and
>> confusing.  We certainly have plenty of other lists that contain
>> plain structs without tags, so I don't buy that the List
>> infrastructure is making you do that.

> This code mixes Expr's and hash entries in the single list.  The point
> of having a NodeTag in the struct is the ability to distinguish them
> later.

If you're doing that, it really really ought to be a proper Node.
If nothing else, that would aid debugging by allowing the list
to be pprint'ed.

			regards, tom lane